/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"

#include "iodefine.h"
#include "sci.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif



//vOR[h6.3
void LED_init(void){
	PORTA.PDR.BIT.B6 = 1;					//porto͂ɐݒ
	PORTB.PDR.BIT.B0 = 1;					//porto͂ɐݒ
	PORTA.PDR.BIT.B4 = 1;					//porto͂ɐݒ
	PORTA.PDR.BIT.B0 = 1;					//porto͂ɐݒ
}

//vOR[h6.3
void _LED(unsigned char data){				//̒lLEDɓ]
	PORTB.PODR.BIT.B0 = data&0x01;
	PORTA.PODR.BIT.B6 = (data>>1)&0x01;
	PORTA.PODR.BIT.B4 = (data>>2)&0x01;
	PORTA.PODR.BIT.B0 = (data>>3)&0x01;
}


//vOR[h8.1
void init_clock(void){
	SYSTEM.PRCR.WORD   = 0xa50b;			//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;			// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;				// PLL ENABLE
	SYSTEM.SCKCR.LONG  = 0x21C21211;		//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;			// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;				// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;			//PLLHI
}

//vNR[h8.3
void buzzer_init(void){
//I/O̐ݒ
	PORTB.PODR.BIT.B3 = 1;
	PORTB.PDR.BIT.B3 = 1;
	PORTB.PMR.BIT.B3 = 0;
	MPC.PWPR.BIT.B0WI=0;
	MPC.PWPR.BIT.PFSWE=1;
	MPC.PB3PFS.BIT.PSEL=1;
	MPC.PWPR.BYTE=0x80;
//MTU0̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	MTU.TSTR.BYTE=0;
	MTU0.TCR.BIT.CCLR=2;
	MTU0.TCR.BIT.TPSC=1;
	MTU0.TMDR.BIT.MD=2;
	MTU0.TIORH.BIT.IOA=5;
	MTU0.TIORH.BIT.IOB=2;
	MTU0.TGRA = (13636 -1);
	MTU0.TGRB = (27272 -1);
	MTU0.TCNT = 0;
}

//vOR[h8.4
void buzzer_on(void){
	MTU0.TCNT = 0;
	PORTB.PMR.BIT.B3 = 1;
	MTU.TSTR.BIT.CST0 = 1;	
}



//vOR[h10.1
void SENSOR_init(void)
{
//I/O̐ݒ
	PORT5.PDR.BIT.B4 = 1;
	PORT0.PDR.BIT.B5 = 1;
	PORT2.PDR.BIT.B7 = 1;
	PORTB.PDR.BIT.B5 = 1;
	PORT5.PODR.BIT.B4 = 0;
	PORT0.PODR.BIT.B5 = 0;
	PORT2.PODR.BIT.B7 = 0;
	PORTB.PODR.BIT.B5 = 0;
	PORTE.PMR.BIT.B1 = 1;
	PORT4.PMR.BIT.B4 = 1;
	PORT4.PMR.BIT.B6 = 1;
	PORT4.PMR.BIT.B2 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.PE1PFS.BIT.ASEL = 1;
	MPC.P44PFS.BIT.ASEL = 1;
	MPC.P46PFS.BIT.ASEL = 1;
	MPC.P42PFS.BIT.ASEL = 1;
	MPC.PWPR.BYTE = 0x80;
//A/D̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(S12AD) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	S12AD.ADCSR.BIT.CKS = 3;
	S12AD.ADCSR.BIT.ADCS = 0;
}
	
//vOR[h10.2
void set_buzzer(int data)
{
	MTU0.TGRB=(int)(12000000/data);
	MTU0.TGRA=MTU0.TGRB/2;
}


//vOR[h10.1
void main(void)
{
	int i;
	
	init_clock();
	LED_init();
	SENSOR_init();
	
	while(1)
	{
		S12AD.ADANS0.WORD = 0x0200;
		PORTB.PODR.BIT.B5 =1;
		for(i=0;i<300;i++);
		S12AD.ADCSR.BIT.ADST=1;
		while(S12AD.ADCSR.BIT.ADST);
		PORTB.PODR.BIT.B5=0;
		_LED(0x00);
		if(S12AD.ADDR9 >100)
			PORTB.PODR.BIT.B0 =1;
		if(S12AD.ADDR9 > 200)
			PORTA.PODR.BIT.B6 =1;
		if(S12AD.ADDR9 > 300)
			PORTA.PODR.BIT.B4 =1;
		if(S12AD.ADDR9 > 400)
			PORTA.PODR.BIT.B0 =1;
		for(i=0;i<3000;i++);
	}
}

/*
//vOR[h10.2
void main(void)
{
	int i;
	
	init_clock();
	SENSOR_init();
	buzzer_init();
	buzzer_on();
	
	while(1)
	{
		S12AD.ADANS0.WORD = 0x0200;
		PORTB.PODR.BIT.B5 =1;
		for(i=0;i<300;i++);
		S12AD.ADCSR.BIT.ADST=1;
		while(S12AD.ADCSR.BIT.ADST);
		PORTB.PODR.BIT.B5=0;
		set_buzzer(S12AD.ADDR9 +200);
		for(i=0;i<3000;i++);
	}
}
*/
/*
//vOR[h10.3
void main(void)
{
	int i;
	
	init_clock();
	SENSOR_init();
	SCI1_INIT();
	
	while(1)
	{
		S12AD.ADANS0.WORD = 0x0200;
		PORTB.PODR.BIT.B5 =1;
		for(i=0;i<300;i++);
		S12AD.ADCSR.BIT.ADST=1;
		while(S12AD.ADCSR.BIT.ADST);
		PORTB.PODR.BIT.B5=0;
		SCI1_PRINTF("\n\r %d" , S12AD.ADDR9);
		for(i=0;i<3000;i++);
	}
}
*/

#ifdef __cplusplus
void abort(void)
{

}
#endif
